/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.tarifas;

import com.rjconsultores.ventaboletos.entidad.VigenciaTarifa;
import com.rjconsultores.ventaboletos.service.VigenciaTarifaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderVigenciaTarifa;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Paging;

/**
 *
 * @author rodrigo
 */
@Controller("busquedaVigenciaTarifaController")
@Scope("prototype")
public class BusquedaVigenciaTarifaController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<VigenciaTarifa> plwVigenciaTarifa;
    @Autowired
    private VigenciaTarifaService vigenciaTarifaService;
    private MyListbox vigenciaList;
    private Paging pagingVigencia;
    private Datebox fecInicio;
    private Datebox fecFinal;
    
    public Datebox getFecFinal() {
        return fecFinal;
    }

    public void setFecFinal(Datebox fecFinal) {
        this.fecFinal = fecFinal;
    }

    public Datebox getFecInicio() {
        return fecInicio;
    }

    public void setFecInicio(Datebox fecInicio) {
        this.fecInicio = fecInicio;
    }

    public Paging getPagingVigencia() {
        return pagingVigencia;
    }

    public void setPagingVigencia(Paging pagingVigencia) {
        this.pagingVigencia = pagingVigencia;
    }

    public MyListbox getVigenciaList() {
        return vigenciaList;
    }

    public void setVigenciaList(MyListbox vigenciaList) {
        this.vigenciaList = vigenciaList;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verVigencia(new VigenciaTarifa());
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        vigenciaList.setItemRenderer(new RenderVigenciaTarifa());
        vigenciaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                VigenciaTarifa vt = (VigenciaTarifa) vigenciaList.getSelected();
                verVigencia(vt);
            }
        });

        refreshLista();
    }

    private void verVigencia(VigenciaTarifa vt) {
        if (vt == null) {
            return;
        }

        Map args = new HashMap();
        args.put("vigenciaTarifa", vt);
        args.put("vigenciaList", vigenciaList);

        openWindow("/gui/tarifas/editarVigenciaTarifa.zul",
                Labels.getLabel("editarVigenciaTarifaController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<VigenciaTarifa> vigenciaTarifaBusqueda =
                new HibernateSearchObject<VigenciaTarifa>(VigenciaTarifa.class, pagingVigencia.getPageSize());
        vigenciaTarifaBusqueda.addFilterEqual("activo", Boolean.TRUE);

        vigenciaTarifaBusqueda.addFilterGreaterOrEqual("feciniciovigencia", fecInicio.getValue());
        vigenciaTarifaBusqueda.addFilterLessOrEqual("fecfinvigencia", fecFinal.getValue());

        vigenciaTarifaBusqueda.addSortAsc("feciniciovigencia");

        plwVigenciaTarifa.init(vigenciaTarifaBusqueda, vigenciaList, pagingVigencia);

        if (vigenciaList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaVigenciaTarifaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }
}
